{ nixpkgs ? import <nixpkgs> {} }:

with nixpkgs;

let
  easy-dhall-nix-src = with builtins;
    fetchgit { inherit (fromJSON (readFile ./easy-dhall-nix.json)) url rev sha256 fetchSubmodules; };
  easy-hls-src = fetchFromGitHub {
    owner = "ssbothwell";
    repo = "easy-hls-nix";
    inherit (builtins.fromJSON (builtins.readFile ./easy-hls-nix.json)) rev sha256;
  };
  easy-hls = callPackage easy-hls-src { ghcVersions = [ hp.ghc.version ]; };
  easy-dhall-nix = import easy-dhall-nix-src {};
  hp = haskellPackages.extend (self: super: {
    reddit_pub = self.callPackage ./. {};
  });

in

hp.shellFor {
  packages = h: [h.reddit_pub];
  withHoogle = true;
  buildInputs = [
    easy-dhall-nix.dhall-lsp-simple
    entr
    cabal-install
    haskellPackages.hlint
    stylish-haskell
    ghcid
    easy-hls

    sqlite-interactive
    rrdtool

    jq

    haskellPackages.graphmod
  ];
}

